<template>
  <v-row>
    <v-col :cols="12">
      <v-card>
        <v-carousel v-model="idx">
          <v-carousel-item v-for="(session, i) in session_list" :key="i">
            <v-sheet height="100%">
              <v-row class="fill-height" align="center" justify="center">
                <v-col :cols="8" style="text-align:center">
                  <div class="text-h2 pa-3">
                    {{ session.device.product_device }}<br />
                  </div>
                  <div class="text-h5" style="color:gray;">
                    <v-divider class="pa-2"></v-divider>
                    {{ session.device.kernel_ver }}
                    {{ session.device.platform_build_id }} |
                    {{ session.device.serial }}
                  </div>
                </v-col>
              </v-row>
            </v-sheet>
          </v-carousel-item>
        </v-carousel>

        <v-card-text>
          <template>
            <v-card-title>
              SELECT APP
            </v-card-title>
            <!-- app list -->
            <v-data-table
              v-model="selected"
              :headers="headers"
              :items="getAppList"
              :single-select="true"
              item-key="name"
              show-select
              hide-default-header
              hide-default-footer
            >
            </v-data-table>
          </template>
        </v-card-text>

        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn text class="mr-3" color="primary" @click="analyze()">
            ANALYZE
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>
import session from "@/service/session";
import manifest from "@/service/manifest";

export default {
  data() {
    return {
      polling: null,
      idx: 0,
      selected: [],
      headers: [
        {
          text: "uid",
          value: "uid"
        },
        {
          text: "name",
          value: "name"
        },
        {
          text: "hash",
          value: "hash"
        }
      ],
      session_list: []
    };
  },
  computed: {
    getAppList() {
      return this.session_list[this.idx]?.applications;
    },
    getDeviceInfo() {
      return this.session_list[this.idx]?.device;
    }
  },
  created() {
    this.getSessionList();
  },

  methods: {
    getSessionList() {
      session.getSessionList().then(res => {
        if (res.data.count > 0) {
          console.log(res.data);
          this.session_list = res.data.sessions;
        } else {
          this.session_list = [];
        }
      });
    },
    getReadyForManifest(app_digest, session_id) {
      manifest.getManifestList().then(res => {
        if (res?.data[app_digest][0]?.status === "done") {
          window.clearInterval(this.polling);
          localStorage.setItem('app_digest', app_digest);
          localStorage.setItem('session_id', session_id)
          this.$router.push({
            path: "dynamic_analysis",
            // query: { app_digest, session_id }
          });
        }
      });
    },
    analyze() {
      if (this.selected[0] === undefined) {
        alert("[+] Please select the app you want to analyze.");
        return;
      }
      let session_id = this.session_list[this.idx]?.id;
      let application = this.selected[0];

      session.startApp(session_id, application.name).then(() => {
        console.log(`${session_id}|${application.name} is started `);
        this.polling = window.setInterval(() => {
          this.getReadyForManifest(application.hash, session_id);
        }, 2000);
      });
    }
  }
};
</script>
